local require = GLOBAL.require
require "mods"
local IsDST = GLOBAL.MOD_API_VERSION == 10

local function AddNoReleaseDeployables(inst)

  local onrightclick_base = inst.OnRightClick

  local function OnRightClick_DS(self, down)
    if not self:UsingMouse() then return end

    if not down then return end

    self.startdragtime = nil

    if self.placer_recipe then
      self:CancelPlacement()
      return
    end

    if not self:IsEnabled() then
      return
    end

    if GLOBAL.TheInput:GetHUDEntityUnderMouse() then
      return
    end

    if not self:GetRightMouseAction() then
      if self.inst.components.inventory.activeitem and
         self.inst.components.inventory.activeitem.components and
         self.inst.components.inventory.activeitem.components.deployable
      then
        -- do nothing
        --print("not return to inventory DS ROG")
      else
        self.inst.components.inventory:ReturnActiveItem()
      end
    end

    if self.inst.inbed then
      self.inst.inbed.components.bed:StopSleeping()
      return
    end

    local action = self:GetRightMouseAction()
    if action then
      self:DoAction(action )
    end

  end

  local function OnRightClick_DST(self, down)
    if not self:UsingMouse() then
      return
    elseif not down then
      if self:IsEnabled() then
        self:RemoteStopControl(GLOBAL.CONTROL_SECONDARY)
      end
      return
    end

    self.startdragtime = nil

    if self.placer_recipe ~= nil then
      self:CancelPlacement()
      return
    end

    if not self:IsEnabled() or GLOBAL.TheInput:GetHUDEntityUnderMouse() ~= nil then
      return
    end

    local act = self:GetRightMouseAction()
    if act == nil then
      if self.inst.components.inventory and
         self.inst.components.inventory.activeitem and
         self.inst.components.inventory.activeitem.components and
         self.inst.components.inventory.activeitem.components.deployable
      then
        -- do nothing
        --print("not return to inventory DST")
      else
        if self.inst.components.inventory then
          self.inst.components.inventory:ReturnActiveItem()
        end
      end
    else
      if not self.ismastersim then
        local position = GLOBAL.TheInput:GetWorldPosition()
        local mouseover = GLOBAL.TheInput:GetWorldEntityUnderMouse()
        local controlmods = self:EncodeControlMods()
        if self.locomotor == nil then
          self.remote_controls[GLOBAL.CONTROL_SECONDARY] = 0
          SendRPCToServer(GLOBAL.RPC.RightClick, act.action.code, position.x, position.z, mouseover, nil, controlmods, act.action.canforce, act.action.mod_name)
        elseif act.action ~= GLOBAL.ACTIONS.WALKTO and self:CanLocomote() then
          act.preview_cb = function()
            self.remote_controls[GLOBAL.CONTROL_SECONDARY] = 0
            local isreleased = not GLOBAL.TheInput:IsControlPressed(GLOBAL.CONTROL_SECONDARY)
            GLOBAL.SendRPCToServer(GLOBAL.RPC.RightClick, act.action.code, position.x, position.z, mouseover, isreleased, controlmods, nil, act.action.mod_name)
          end
        end
      end

      self:DoAction(act)
    end
  end

  if IsDST then
    inst.OnRightClick = OnRightClick_DST
  else
    inst.OnRightClick = OnRightClick_DS
  end
end

AddClassPostConstruct("components/playercontroller", AddNoReleaseDeployables)
